Index: /bidspace/src/main/java/geniusweb/bidspace/AllBidsList.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/AllBidsList.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/AllBidsList.java	(revision 1)
@@ -26,8 +26,6 @@
 
 	/**
-	 * This object contains s list containing all bids in the space. This is an
-	 * ImmutableList so it can contain all bids without pre-computing them.
-	 * 
-	 * @param domain the {@link Domain}
+	 * A list containing all bids in the space. This is an ImmutableList so it
+	 * can contain all bids without pre-computing them.
 	 * 
 	 */
Index: /bidspace/src/main/java/geniusweb/bidspace/AllPartialBidsList.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/AllPartialBidsList.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/AllPartialBidsList.java	(revision 1)
@@ -32,5 +32,4 @@
 	 * pre-computing them.
 	 * 
-	 * @param domain the {@link Domain}
 	 */
 	public AllPartialBidsList(Domain domain) {
Index: /bidspace/src/main/java/geniusweb/bidspace/FrequencyOpponentModel.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/FrequencyOpponentModel.java	(revision 1)
+++ /bidspace/src/main/java/geniusweb/bidspace/FrequencyOpponentModel.java	(revision 1)
@@ -0,0 +1,194 @@
+package geniusweb.bidspace;
+
+import java.math.BigDecimal;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.profile.utilityspace.NumberValueSetUtilities;
+
+/**
+ * implements an {@link OpponentModel} by counting frequencies of bids placed by
+ * the opponent.
+ * <p>
+ * NOTE: {@link NumberValue}s are also treated as 'discrete', so the frequency
+ * of one value does not influence the influence the frequency of nearby values
+ * (as you might expect as {@link NumberValueSetUtilities} is only affected by
+ * the endpoints).
+ *
+ */
+public class FrequencyOpponentModel implements OpponentModel {
+
+	private static final int DECIMALS = 4; // accuracy of our computations.
+	private final Domain domain;
+	private final Map<String, Map<Value, Integer>> bidFrequencies;
+	private final BigDecimal totalBids;
+	private static int serial = 1; // counter for auto name generation
+
+	public FrequencyOpponentModel(Domain domain) {
+		// map with empth hashmap for each issue.
+		this(domain,
+				domain.getIssues().stream().collect(
+						Collectors.toMap(iss -> iss, iss -> new HashMap<>())),
+				BigDecimal.ZERO);
+	}
+
+	@Override
+	public BigDecimal getUtility(Bid bid) {
+		String err = domain.isComplete(bid);
+		if (err != null) {
+			throw new IllegalArgumentException(err);
+		}
+		if (totalBids == BigDecimal.ZERO) {
+			return BigDecimal.ONE;
+		}
+		BigDecimal sum = BigDecimal.ZERO;
+		// Assume all issues have equal weight.
+		for (String issue : domain.getIssues()) {
+			sum = sum.add(getFraction(issue, bid.getValue(issue)));
+		}
+		return sum.divide(new BigDecimal(bidFrequencies.size()), DECIMALS,
+				BigDecimal.ROUND_HALF_UP);
+	}
+
+	@Override
+	public String getName() {
+		return "FreqOppModel" + (serial++) + "For" + domain;
+	}
+
+	/**
+	 * 
+	 * @param issue the issue to check
+	 * @param value the value to check
+	 * @return the fraction of the total cases that bids contained given value
+	 *         for the issue.
+	 */
+	private BigDecimal getFraction(String issue, Value value) {
+		if (totalBids == BigDecimal.ZERO) {
+			return BigDecimal.ONE;
+		}
+		Integer freq = bidFrequencies.get(issue).get(value);
+		if (freq == null) {
+			freq = 0;
+		}
+		return new BigDecimal(freq).divide(totalBids, DECIMALS,
+				BigDecimal.ROUND_HALF_UP);
+	}
+
+	@Override
+	public Domain getDomain() {
+		return domain;
+	}
+
+	@Override
+	public OpponentModel update(Bid bid) {
+		String err = domain.isComplete(bid);
+		if (err != null) {
+			throw new IllegalArgumentException(err);
+		}
+		Map<String, Map<Value, Integer>> newFreqs = cloneMap(bidFrequencies);
+		for (String issue : domain.getIssues()) {
+			Map<Value, Integer> freqs = newFreqs.get(issue);
+			Value value = bid.getValue(issue);
+			Integer oldfreq = freqs.get(value);
+			if (oldfreq == null) {
+				oldfreq = 0;
+			}
+			freqs.put(value, oldfreq + 1);
+		}
+
+		return new FrequencyOpponentModel(domain, newFreqs,
+				totalBids.add(BigDecimal.ONE));
+	}
+
+	/**
+	 * internal constructor. Assumes the freqs keyset is equal to the available
+	 * issues.
+	 * 
+	 * @param domain the domain
+	 * @param freqs  the observed frequencies for all issue values. This map is
+	 *               assumed to be a fresh private-access only copy.
+	 * @param total  the total number of bids contained in the freqs map. This
+	 *               must be equal to the sum of the Integer values in the
+	 *               {@link #bidFrequencies} for each issue (this is not
+	 *               checked).
+	 */
+	private FrequencyOpponentModel(Domain domain,
+			Map<String, Map<Value, Integer>> freqs, BigDecimal total) {
+		if (domain == null) {
+			throw new NullPointerException("domain=null");
+		}
+		this.domain = domain;
+		this.bidFrequencies = freqs;
+		this.totalBids = total;
+	}
+
+	/**
+	 * 
+	 * @param freqs
+	 * @return deep copy of freqs map.
+	 */
+	private static Map<String, Map<Value, Integer>> cloneMap(
+			Map<String, Map<Value, Integer>> freqs) {
+		Map<String, Map<Value, Integer>> map = new HashMap<>();
+		for (String issue : freqs.keySet()) {
+			map.put(issue, new HashMap<Value, Integer>(freqs.get(issue)));
+		}
+		return map;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((bidFrequencies == null) ? 0 : bidFrequencies.hashCode());
+		result = prime * result + ((domain == null) ? 0 : domain.hashCode());
+		result = prime * result
+				+ ((totalBids == null) ? 0 : totalBids.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		FrequencyOpponentModel other = (FrequencyOpponentModel) obj;
+		if (bidFrequencies == null) {
+			if (other.bidFrequencies != null)
+				return false;
+		} else if (!bidFrequencies.equals(other.bidFrequencies))
+			return false;
+		if (domain == null) {
+			if (other.domain != null)
+				return false;
+		} else if (!domain.equals(other.domain))
+			return false;
+		if (totalBids == null) {
+			if (other.totalBids != null)
+				return false;
+		} else if (!totalBids.equals(other.totalBids))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "FrequencyOpponentModel[" + totalBids + "," + bidFrequencies
+				+ "]";
+	}
+
+	@Override
+	public Bid getReservationBid() {
+		throw new UnsupportedOperationException();
+	}
+
+}
Index: /bidspace/src/main/java/geniusweb/bidspace/OpponentModel.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/OpponentModel.java	(revision 1)
+++ /bidspace/src/main/java/geniusweb/bidspace/OpponentModel.java	(revision 1)
@@ -0,0 +1,18 @@
+package geniusweb.bidspace;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.profile.utilityspace.UtilitySpace;
+
+/**
+ * An opponentmodel estimates a {@link UtilitySpace} from received opponent
+ * bids.
+ */
+public interface OpponentModel extends UtilitySpace {
+	/**
+	 *
+	 * @param bid the next bid that was received
+	 * @return a new {@link OpponentModel} that takes the next bid into account.
+	 */
+	OpponentModel update(Bid bid);
+
+}
Index: /bidspace/src/main/java/geniusweb/bidspace/pareto/GenericPareto.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/pareto/GenericPareto.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/pareto/GenericPareto.java	(revision 1)
@@ -1,6 +1,4 @@
 package geniusweb.bidspace.pareto;
 
-import java.util.ArrayList;
-import java.util.Collections;
 import java.util.HashSet;
 import java.util.List;
@@ -16,11 +14,10 @@
 /**
  * A set of all pareto points associated with a set of profiles. Generally
- * applicable but slow. It is recommended to use {@link ParetoLinearAdditive} if
- * applicable.
+ * applicable but slow.
  */
 public class GenericPareto implements ParetoFrontier {
 
 	private final List<? extends PartialOrdering> profiles;
-	private transient Set<Bid> paretobids = null; // cache
+	private Set<Bid> paretobids = null;
 
 	/**
@@ -38,5 +35,5 @@
 					"at least 2 profiles are needed");
 		}
-		if (profiles.contains(null)) {
+		if (profiles.stream().anyMatch(profile -> profile == null)) {
 			throw new IllegalArgumentException("Profiles must not be null");
 		}
@@ -49,10 +46,10 @@
 			}
 		}
-		this.profiles = new ArrayList<>(profiles);
+		this.profiles = profiles;
 	}
 
 	@Override
-	public List<Profile> getProfiles() {
-		return Collections.unmodifiableList(profiles);
+	public List<? extends Profile> getProfiles() {
+		return profiles;
 	}
 
@@ -61,5 +58,5 @@
 		if (paretobids == null)
 			computePareto();
-		return Collections.unmodifiableSet(paretobids);
+		return paretobids;
 	}
 
Index: /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoLinearAdditive.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoLinearAdditive.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoLinearAdditive.java	(revision 1)
@@ -10,13 +10,13 @@
 import geniusweb.issuevalue.Domain;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
 /**
- * pareto frontier implementation for {@link LinearAdditive}. This is a highly
- * optimized pareto method for {@link LinearAdditive} spaces
+ * pareto frontier implementation for {@link LinearAdditiveUtilitySpace}.
+ * Simplistic implementation that iterates over all bids.
  */
 public class ParetoLinearAdditive implements ParetoFrontier {
 
-	private final List<LinearAdditive> utilSpaces;
+	private final List<LinearAdditiveUtilitySpace> utilSpaces;
 	private Set<Bid> points = null;
 	// all issues in a deterministic order
@@ -24,8 +24,9 @@
 	/**
 	 * 
-	 * @param utilSpaces. Must contain at least two {@link LinearAdditive}s and
-	 *                    all must be defined on the same donain.
+	 * @param utilSpaces. Must contain at least two
+	 *                    {@link LinearAdditiveUtilitySpace}s and all must be
+	 *                    defined on the same donain.
 	 */
-	public ParetoLinearAdditive(List<LinearAdditive> utilSpaces) {
+	public ParetoLinearAdditive(List<LinearAdditiveUtilitySpace> utilSpaces) {
 		if (utilSpaces == null || utilSpaces.size() < 2) {
 			throw new IllegalArgumentException(
@@ -33,5 +34,5 @@
 		}
 		Domain domain = utilSpaces.get(0).getDomain();
-		for (LinearAdditive space : utilSpaces) {
+		for (LinearAdditiveUtilitySpace space : utilSpaces) {
 			if (!space.getDomain().equals(domain)) {
 				throw new IllegalArgumentException(
Index: /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoPoint.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoPoint.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/pareto/ParetoPoint.java	(revision 1)
@@ -3,9 +3,12 @@
 import java.math.BigDecimal;
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Map;
 
 import geniusweb.issuevalue.Bid;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.issuevalue.Value;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
 /**
@@ -23,10 +26,10 @@
 	 * 
 	 * @param bid    a (possibly partial) {@link Bid}
-	 * @param spaces the {@link LinearAdditive}s to consider
+	 * @param spaces the {@link LinearAdditiveUtilitySpace}s to consider
 	 */
-	public ParetoPoint(Bid bid, List<LinearAdditive> spaces) {
+	public ParetoPoint(Bid bid, List<LinearAdditiveUtilitySpace> spaces) {
 		this.bid = bid;
 		utilities = new ArrayList<>();
-		for (LinearAdditive space : spaces) {
+		for (LinearAdditiveUtilitySpace space : spaces) {
 			utilities.add(space.getUtility(bid));
 		}
@@ -46,4 +49,11 @@
 	 */
 	public ParetoPoint merge(ParetoPoint otherpoint) {
+		Map<String, Value> issuevalues = new HashMap<>();
+		for (String issue : bid.getIssues()) {
+			issuevalues.put(issue, bid.getValue(issue));
+		}
+		for (String issue : otherpoint.bid.getIssues()) {
+			issuevalues.put(issue, otherpoint.bid.getValue(issue));
+		}
 		List<BigDecimal> summedutils = new LinkedList<>();
 		for (int n = 0; n < utilities.size(); n++) {
@@ -51,5 +61,5 @@
 		}
 
-		return new ParetoPoint(summedutils, bid.merge(otherpoint.getBid()));
+		return new ParetoPoint(summedutils, new Bid(issuevalues));
 	}
 
Index: /bidspace/src/main/java/geniusweb/bidspace/pareto/PartialPareto.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/pareto/PartialPareto.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/pareto/PartialPareto.java	(revision 1)
@@ -8,5 +8,5 @@
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Value;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
 /**
@@ -28,5 +28,5 @@
 	 * implemented recursively (O(log(#issues))).
 	 * 
-	 * @param utilSpaces the {@link LinearAdditive}s
+	 * @param utilSpaces the {@link LinearAdditiveUtilitySpace}s
 	 * @param issues     the issues (subset of all issues in the space) to be
 	 *                   used for this pareto
@@ -34,6 +34,6 @@
 	 *         given issues.
 	 */
-	public static PartialPareto create(List<LinearAdditive> utilSpaces,
-			List<String> issues) {
+	public static PartialPareto create(
+			List<LinearAdditiveUtilitySpace> utilSpaces, List<String> issues) {
 
 		if (issues.size() == 1) {
Index: /bidspace/src/test/java/geniusweb/bidspace/FrequencyOppModelTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/FrequencyOppModelTest.java	(revision 1)
+++ /bidspace/src/test/java/geniusweb/bidspace/FrequencyOppModelTest.java	(revision 1)
@@ -0,0 +1,138 @@
+package geniusweb.bidspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.math.BigDecimal;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Test;
+
+import geniusweb.bidspace.FrequencyOpponentModel;
+import geniusweb.bidspace.OpponentModel;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.DiscreteValueSet;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.NumberValueSet;
+import geniusweb.issuevalue.Value;
+import geniusweb.issuevalue.ValueSet;
+import tudelft.utilities.junit.GeneralTests;
+
+public class FrequencyOppModelTest extends GeneralTests<FrequencyOpponentModel> {
+	private final static String ISS1 = "issue1";
+	private final static String ISS2 = "issue2";
+	private static final DiscreteValue I1V1 = new DiscreteValue("i1v1");
+	private static final DiscreteValue I1V2 = new DiscreteValue("i1v2");
+	private static final DiscreteValue I1V2b = new DiscreteValue("i1v2b");
+
+	private static Domain domain, domain2, domain3;
+	private static FrequencyOpponentModel oppModel1, oppModel1b, oppModel2, oppModel3, oppModel4;
+
+	private final static List<List<Bid>> list = new LinkedList<>();
+
+	private final static Bid bid1, bid2, bid3;
+	private static final BigDecimal HALF = new BigDecimal("0.5");
+
+	static {
+		Map<String, ValueSet> issues = new HashMap<>();
+		Collection<DiscreteValue> discretevalues1 = new LinkedList<>();
+		discretevalues1.add(I1V1);
+		discretevalues1.add(I1V2);
+		DiscreteValueSet values1 = new DiscreteValueSet(discretevalues1);
+		issues.put(ISS1, values1);
+		NumberValueSet values2 = new NumberValueSet(BigDecimal.ZERO, BigDecimal.TEN, new BigDecimal("0.3"));
+		issues.put(ISS2, values2);
+		domain = new Domain("test", issues);
+		domain2 = new Domain("test2", issues);
+
+		// slightly different issue1
+		issues = new HashMap<>();
+		discretevalues1 = new LinkedList<>();
+		discretevalues1.add(I1V1);
+		discretevalues1.add(I1V2b);
+		values1 = new DiscreteValueSet(discretevalues1);
+		issues.put(ISS1, values1);
+		values2 = new NumberValueSet(BigDecimal.ZERO, BigDecimal.TEN, new BigDecimal("0.3"));
+		issues.put(ISS2, values2);
+		domain3 = new Domain("test", issues);
+
+		// all bids are for domain
+		Map<String, Value> issuevalues = new HashMap<>();
+		issuevalues.put(ISS1, I1V1);
+		issuevalues.put(ISS2, new NumberValue(new BigDecimal("1.2")));
+		bid1 = new Bid(issuevalues);
+
+		issuevalues.put(ISS1, I1V1);
+		issuevalues.put(ISS2, new NumberValue(new BigDecimal("1.5")));
+		bid2 = new Bid(issuevalues);
+
+		issuevalues.put(ISS1, I1V2);
+		issuevalues.put(ISS2, new NumberValue(new BigDecimal("1.5")));
+		bid3 = new Bid(issuevalues);
+
+		oppModel1 = new FrequencyOpponentModel(domain);
+		oppModel1b = new FrequencyOpponentModel(domain);
+		oppModel2 = new FrequencyOpponentModel(domain2);
+		oppModel3 = new FrequencyOpponentModel(domain3);
+		oppModel4 = (FrequencyOpponentModel) oppModel3.update(bid1);
+
+	}
+
+	@Override
+	public List<List<FrequencyOpponentModel>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(oppModel1, oppModel1b), Arrays.asList(oppModel2), Arrays.asList(oppModel3),
+				Arrays.asList(oppModel4));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("FrequencyOpponentModel\\[0,\\{issue2=\\{\\}, issue1=\\{\\}\\}\\]",
+				"FrequencyOpponentModel\\[0,\\{issue2=\\{\\}, issue1=\\{\\}\\}\\]",
+				"FrequencyOpponentModel\\[0,\\{issue2=\\{\\}, issue1=\\{\\}\\}\\]",
+				"FrequencyOpponentModel\\[1,\\{issue2=\\{1.2=1\\}, issue1=\\{\"i1v1\"=1\\}\\}\\]");
+	}
+
+	@Test(expected = NullPointerException.class)
+	public void smokeNullTest() {
+		new FrequencyOpponentModel(null);
+	}
+
+	@Test
+	public void smokeTest() {
+		new FrequencyOpponentModel(domain);
+	}
+
+	@Test
+	public void testEmptyModel() {
+		FrequencyOpponentModel oppModel = new FrequencyOpponentModel(domain);
+		assertEquals(BigDecimal.ONE, oppModel.getUtility(bid1));
+		assertEquals(BigDecimal.ONE, oppModel.getUtility(bid2));
+	}
+
+	@Test
+	public void testUpdate() {
+		OpponentModel oppModel = oppModel1.update(bid1);
+		assertTrue(BigDecimal.ONE.compareTo(oppModel.getUtility(bid1)) == 0);
+		assertTrue(BigDecimal.ZERO.compareTo(oppModel.getUtility(bid3)) == 0);
+		// bid2 has 1 of 2 issue values same as bid1.
+		assertTrue(HALF.compareTo(oppModel.getUtility(bid2)) == 0);
+	}
+
+	@Test
+	public void testUpdate2() {
+		// bid1 and bid2 both want I1V1. They differ on the number value.
+		// bid3 wants I1V2 but does have the number value from bid2
+		OpponentModel oppModel = oppModel1.update(bid1).update(bid2);
+		assertTrue(new BigDecimal("0.75").compareTo(oppModel.getUtility(bid1)) == 0);
+		assertTrue(new BigDecimal("0.75").compareTo(oppModel.getUtility(bid2)) == 0);
+		assertTrue(new BigDecimal("0.25").compareTo(oppModel.getUtility(bid3)) == 0);
+	}
+
+}
Index: /bidspace/src/test/java/geniusweb/bidspace/pareto/GenericParetoTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/pareto/GenericParetoTest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/pareto/GenericParetoTest.java	(revision 1)
@@ -2,11 +2,10 @@
 
 import static org.junit.Assert.assertEquals;
-import static org.mockito.ArgumentMatchers.any;
-import static org.mockito.ArgumentMatchers.eq;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.eq;
 import static org.mockito.Mockito.mock;
 import static org.mockito.Mockito.when;
 
 import java.math.BigDecimal;
-import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Collection;
@@ -15,9 +14,8 @@
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
 
-import org.junit.Before;
 import org.junit.Test;
 
+import geniusweb.bidspace.pareto.GenericPareto;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
@@ -29,5 +27,4 @@
 import geniusweb.issuevalue.ValueSet;
 import geniusweb.profile.PartialOrdering;
-import geniusweb.profile.Profile;
 
 public class GenericParetoTest {
@@ -42,17 +39,13 @@
 	private static final Map<String, ValueSet> issues = new HashMap<>();
 
-	private static ValueSet values1;
-	private static ValueSet values2;
+	private static final ValueSet values1;
+	private static final ValueSet values2;
 	private static final BigDecimal TWO = new BigDecimal("2");
 	private static final BigDecimal THREE = new BigDecimal("3");
 
-	private static Domain domain;
+	private static final Domain domain;
 	private static Bid bid1, bid2, bid3;
 
-	private PartialOrdering profile1, profile2, profile3;
-	private GenericPareto pareto;
-
-	@Before
-	public void before() {
+	static {
 		Collection<DiscreteValue> discretevalues1 = new LinkedList<>();
 		discretevalues1.add(I1V1);
@@ -77,17 +70,13 @@
 		bid3 = new Bid(issuevalues);
 
-		profile1 = mock(PartialOrdering.class);
-		profile2 = mock(PartialOrdering.class);
-		profile3 = mock(PartialOrdering.class);
-		when(profile1.getDomain()).thenReturn(domain);
-		when(profile2.getDomain()).thenReturn(domain);
-		when(profile3.getDomain()).thenReturn(domain);
-
-		pareto = new GenericPareto(Arrays.asList(profile1, profile2));
-
 	}
 
 	@Test
 	public void genericParetoTest() {
+		PartialOrdering profile1 = mock(PartialOrdering.class);
+		PartialOrdering profile2 = mock(PartialOrdering.class);
+
+		when(profile1.getDomain()).thenReturn(domain);
+		when(profile2.getDomain()).thenReturn(domain);
 
 		// fefault: there is no preference at all, all isPreferredOrEqual
@@ -103,4 +92,9 @@
 	@Test
 	public void genericParetoTest1() {
+		PartialOrdering profile1 = mock(PartialOrdering.class);
+		PartialOrdering profile2 = mock(PartialOrdering.class);
+
+		when(profile1.getDomain()).thenReturn(domain);
+		when(profile2.getDomain()).thenReturn(domain);
 
 		// both prefer bid1 over any other bid.
@@ -109,4 +103,7 @@
 		when(profile2.isPreferredOrEqual(eq(bid1), any(Bid.class)))
 				.thenReturn(true);
+
+		List<PartialOrdering> profiles = Arrays.asList(profile1, profile2);
+		GenericPareto pareto = new GenericPareto(profiles);
 
 		Collection<Bid> points = pareto.getPoints();
@@ -117,4 +114,9 @@
 	@Test
 	public void genericParetoTest2() {
+		PartialOrdering profile1 = mock(PartialOrdering.class);
+		PartialOrdering profile2 = mock(PartialOrdering.class);
+
+		when(profile1.getDomain()).thenReturn(domain);
+		when(profile2.getDomain()).thenReturn(domain);
 
 		// both prefer bid2 over any other bid.
@@ -123,4 +125,6 @@
 		when(profile2.isPreferredOrEqual(eq(bid2), any(Bid.class)))
 				.thenReturn(true);
+		List<PartialOrdering> profiles = Arrays.asList(profile1, profile2);
+		GenericPareto pareto = new GenericPareto(profiles);
 
 		Collection<Bid> points = pareto.getPoints();
@@ -132,4 +136,10 @@
 	@Test
 	public void genericParetoTest3() {
+		PartialOrdering profile1 = mock(PartialOrdering.class);
+		PartialOrdering profile2 = mock(PartialOrdering.class);
+
+		when(profile1.getDomain()).thenReturn(domain);
+		when(profile2.getDomain()).thenReturn(domain);
+
 		// profile1 prefers bid1, profile2 prefers bid2.
 		// now neither bid1 nor bid2 are dominating each other
@@ -139,4 +149,6 @@
 		when(profile2.isPreferredOrEqual(eq(bid2), any(Bid.class)))
 				.thenReturn(true);
+		List<PartialOrdering> profiles = Arrays.asList(profile1, profile2);
+		GenericPareto pareto = new GenericPareto(profiles);
 
 		Collection<Bid> points = pareto.getPoints();
@@ -147,4 +159,9 @@
 	@Test
 	public void genericParetoTest4() {
+		PartialOrdering profile1 = mock(PartialOrdering.class);
+		PartialOrdering profile2 = mock(PartialOrdering.class);
+
+		when(profile1.getDomain()).thenReturn(domain);
+		when(profile2.getDomain()).thenReturn(domain);
 
 		// profile1 prefers bid1, profile2 prefers bid2.
@@ -158,4 +175,6 @@
 		when(profile2.isPreferredOrEqual(eq(bid2), any(Bid.class)))
 				.thenReturn(true);
+		List<PartialOrdering> profiles = Arrays.asList(profile1, profile2);
+		GenericPareto pareto = new GenericPareto(profiles);
 
 		Collection<Bid> points = pareto.getPoints();
@@ -164,31 +183,3 @@
 	}
 
-	@Test(expected = IllegalArgumentException.class)
-	public void testNullNotOk() {
-		new GenericPareto(Arrays.asList(profile1, null, profile1));
-	}
-
-	@Test
-	public void testImmutable() {
-		List<PartialOrdering> list = new ArrayList<>(
-				Arrays.asList(profile1, profile2));
-		GenericPareto pareto = new GenericPareto(list);
-		// if we modify the list, the pareto should not change
-		list.add(profile3);
-		assertEquals(2, pareto.getProfiles().size());
-	}
-
-	@Test(expected = UnsupportedOperationException.class)
-	public void testGetParetoAndAdd() {
-		List<Profile> list = pareto.getProfiles();
-		list.add(profile3);
-
-	}
-
-	@Test(expected = UnsupportedOperationException.class)
-	public void testGetPointsAndAdd() {
-		Set<Bid> list = pareto.getPoints();
-		list.add(bid1);
-	}
-
 }
Index: /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoE2Etest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoE2Etest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoE2Etest.java	(revision 1)
@@ -19,6 +19,8 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.bidspace.pareto.GenericPareto;
+import geniusweb.bidspace.pareto.ParetoFrontier;
+import geniusweb.bidspace.pareto.ParetoLinearAdditive;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
@@ -36,5 +38,5 @@
 						"src/test/resources/jobs/jobs2.json", 18 },
 				{ "src/test/resources/7issues/7issues1.json",
-						"src/test/resources/7issues/7issues2.json", 557 } });
+						"src/test/resources/7issues/7issues2.json", 351 } });
 	}
 
@@ -59,5 +61,5 @@
 				.readValue(file2, Profile.class);
 
-		List<LinearAdditive> profiles = new LinkedList<>();
+		List<LinearAdditiveUtilitySpace> profiles = new LinkedList<>();
 		profiles.add(profile1);
 		profiles.add(profile2);
Index: /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoPointTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoPointTest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoPointTest.java	(revision 1)
@@ -4,5 +4,5 @@
 import static org.junit.Assert.assertFalse;
 import static org.junit.Assert.assertTrue;
-import static org.mockito.ArgumentMatchers.eq;
+import static org.mockito.Matchers.eq;
 import static org.mockito.Mockito.mock;
 import static org.mockito.Mockito.when;
@@ -10,13 +10,13 @@
 import java.math.BigDecimal;
 import java.util.Arrays;
-import java.util.HashMap;
-import java.util.Map;
+import java.util.HashSet;
 
 import org.junit.Before;
 import org.junit.Test;
 
+import geniusweb.bidspace.pareto.ParetoPoint;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Value;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
 public class ParetoPointTest {
@@ -26,6 +26,7 @@
 	private static final BigDecimal D0_4 = BigDecimal.valueOf(0.4);
 	private static final BigDecimal D0_5 = BigDecimal.valueOf(0.5);
-	private final LinearAdditive space1 = mock(LinearAdditive.class),
-			space2 = mock(LinearAdditive.class);
+	private final LinearAdditiveUtilitySpace space1 = mock(
+			LinearAdditiveUtilitySpace.class),
+			space2 = mock(LinearAdditiveUtilitySpace.class);
 	private final Bid bid11 = mock(Bid.class), bid12 = mock(Bid.class),
 			bid21 = mock(Bid.class), bid22 = mock(Bid.class);
@@ -86,15 +87,21 @@
 	@Test
 	public void mergeTest() {
+		// partial bid 020_010 has value 0.2 for issue 2 in space1 and 0.1 for
+		// issue 2 in space2.
+		Bid partialbid020_010 = mock(Bid.class),
+				partialbid102_301 = mock(Bid.class);
+		// merged this should be a bid 122_311 so it has utilities
+		// 1+2+2=0.5 in space1 and 3+1+1=0.5 in space2
+
+		when(partialbid020_010.getIssues())
+				.thenReturn(new HashSet<String>(Arrays.asList("issue2")));
+		when(partialbid102_301.getIssues()).thenReturn(
+				new HashSet<String>(Arrays.asList("issue1", "issue3")));
+
 		Value value1 = mock(Value.class), value2 = mock(Value.class),
 				value3 = mock(Value.class);
-		// partial bid 020_010 has value 0.2 for issue 2 in space1 and 0.1 for
-		// issue 2 in space2.
-		Bid partialbid020_010 = new Bid("issue2", value2);
-		Map<String, Value> vals2 = new HashMap<>();
-		vals2.put("issue1", value1);
-		vals2.put("issue3", value3);
-		Bid partialbid102_301 = new Bid(vals2);
-		// merged this should be a bid 122_311 so it has utilities
-		// 1+2+2=0.5 in space1 and 3+1+1=0.5 in space2
+		when(partialbid020_010.getValue(eq("issue2"))).thenReturn(value2);
+		when(partialbid102_301.getValue(eq("issue1"))).thenReturn(value1);
+		when(partialbid102_301.getValue(eq("issue3"))).thenReturn(value3);
 
 		when(space1.getUtility(eq(partialbid020_010))).thenReturn(D0_2);
@@ -110,4 +117,11 @@
 		ParetoPoint p = p1.merge(p2);
 		Bid bid = p.getBid();
+		assertEquals(
+				new HashSet<String>(
+						Arrays.asList("issue1", "issue2", "issue3")),
+				bid.getIssues());
+		assertEquals(value1, bid.getValue("issue1"));
+		assertEquals(value2, bid.getValue("issue2"));
+		assertEquals(value3, bid.getValue("issue3"));
 		assertEquals(D0_5, p.getUtilities().get(0));
 		assertEquals(D0_5, p.getUtilities().get(1));
Index: /bidspace/src/test/java/geniusweb/bidspace/pareto/PartialParetoTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/pareto/PartialParetoTest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/pareto/PartialParetoTest.java	(revision 1)
@@ -16,9 +16,10 @@
 import org.junit.Test;
 
+import geniusweb.bidspace.pareto.PartialPareto;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Domain;
 import geniusweb.issuevalue.Value;
 import geniusweb.issuevalue.ValueSet;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 
 public class PartialParetoTest {
@@ -30,6 +31,7 @@
 	private static final BigDecimal D0_5 = BigDecimal.valueOf(0.5);
 
-	private final LinearAdditive space1 = mock(LinearAdditive.class),
-			space2 = mock(LinearAdditive.class);
+	private final LinearAdditiveUtilitySpace space1 = mock(
+			LinearAdditiveUtilitySpace.class),
+			space2 = mock(LinearAdditiveUtilitySpace.class);
 
 	private Domain domain = mock(Domain.class);
